#Noesis python importer - EA FIFA 06 stadium model .rx2 files - version 1.0 no materials and textures
from inc_noesis import *
import noesis
#rapi methods should only be used during handler callbacks
import rapi
#registerNoesisTypes is called by Noesis to allow the script to register formats.
#Do not implement this function in script files unless you want them to be dedicated format modules!
def registerNoesisTypes():
	handle = noesis.register("FIFA 06 stadiums (X360)", ".rx2")
	noesis.setHandlerTypeCheck(handle, noepyCheckType)
	noesis.setHandlerLoadModel(handle, noepyLoadModel)
	noesis.logPopup()
	#print("The log can be useful for catching debug prints from preview loads.\nBut don't leave it on when you release your script, or it will probably annoy people.")
	return 1
#check if it's this type based on the data
def noepyCheckType(data):
    bs = NoeBitStream(data)
    Magic = bs.readBytes(7)
    if Magic != b'\x89\x52\x57\x34\x78\x62\x32':
        return 0
    return 1  

#load the model
def noepyLoadModel(data, mdlList):
   fOffset =[]
   fBuffer =[]
   FBufferSize = []
   meshInfo = []
   ctx = rapi.rpgCreateContext()
   bs = NoeBitStream(data, NOE_BIGENDIAN)
   bs.seek(0x20, NOESEEK_ABS)
   fileCount = bs.read(">i")
   bs.seek(12, NOESEEK_REL)
   fileTable = bs.read(">i")
   bs.seek(fileTable[0], NOESEEK_ABS)
   meshCount = 0
   
   for i in range(0, fileCount[0]):
	    fileInfo = bs.read(">iiiii")
	    fileType = fileInfo[4]
	   			    
	    fOffset.append([fileInfo[0]])
	    fBuffer.append([fileInfo[2]])
	    
	    if fileType == 0x21:
	   		meshInfo.append([fileInfo[0]])
	   		meshCount +=1		 			   	 
   
   for i in range(0, meshCount):	
   		rapi.rpgClearBufferBinds()
   		bs.seek(meshInfo[i][0], NOESEEK_ABS)
   		meshParts = bs.read(">iiii")
   		faceID = meshParts[2]
   		vertexID = meshParts[3]
   		
   		bs.seek(fOffset[vertexID][0], NOESEEK_ABS)
   		vertInfo = bs.read(">iiiiiHHii")
   		VBsize = vertInfo[5]
   		VCount = vertInfo[7]
   		descriptorID = vertInfo[8]
   		vOffset = (vertInfo[3] - 3) // 4

   		
   		bs.seek(fOffset[faceID][0], NOESEEK_ABS)
   		faceInfo = bs.read(">iiiiii")
   		triangleCount = faceInfo[5]
   		FCount = faceInfo[4]
   		iOffset = faceInfo[3]
   		
   		bs.seek(fOffset[descriptorID][0], NOESEEK_ABS)
   		
   		UVCount = 0
   		UV2Count = 0
   		UV3Count = 0
   		UV4Count = 0
   		UV5Count = 0
   		COLCount = 0
   		VertType = 0
   		UVtype = 0
   		UV2type = 0
   		UV3type = 0
   		UV4type = 0
   		UV5type = 0
   		COLtype = 0
   		
   		info = bs.read(">iBBBBBBBB")
   		for j in range(0, info[2]):
   			position = bs.read(">i")
   			type = bs.readBytes(8)
   			if type == b'\x00\x2A\x23\xB9\x00\x00\x00\x01':
   				VertType = 1   			
   			elif type == b'\x00\x1A\x23\x60\x00\x00\x00\x01':
   				VertType = 2   			
   			elif type == b'\x00\x1A\x23\xA6\x00\x00\x00\x01':
   				VertType = 3
   				
   			if type == b'\x00\x2C\x23\xA5\x00\x05\x00\x06':
   				UVpos = position[0]
   				UVtype = 1
   			elif type == b'\x00\x2C\x20\x59\x00\x05\x00\x06':
   				UVpos = position[0]
   				UVtype = 2
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x00\x06':
   				UVpos = position[0]
   				UVtype = 3
   			elif type == b'\x00\x2C\x21\x59\x00\x05\x00\x06':
   				UVpos = position[0]
   				UVtype = 4

   			if type == b'\x00\x2C\x23\xA5\x00\x05\x01\x07':
   				UV2pos = position[0]
   				UV2type = 1
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x01\x07':
   				UV2pos = position[0]
   				UV2type = 2
   					
   			if type == b'\x00\x2C\x23\xA5\x00\x05\x02\x08':
   				UV3pos = position[0]
   				UV3type = 1
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x02\x08':
   				UV3pos = position[0]
   				UV3type = 2
   				
   			if type == b'\x00\x2C\x23\xA5\x00\x05\x03\x09':
   				UV4pos = position[0]
   				UV4type = 1
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x03\x09':
   				UV4pos = position[0]
   				UV4type = 2
   					
   			if type == b'\x00\x2C\x23\xA5\x00\x05\x04\x0A':
   				UV5pos = position[0]
   				UV5type = 1
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x04\x0A':
   				UV5pos = position[0]
   				UV5type = 2
   					
   			if type == b'\x00\x18\x28\x86\x00\x0A\x00\x04':
   				COLpos = position[0]
   				COLtype = 1

   		

   			bs.seek(fOffset[vOffset][0], NOESEEK_ABS) #Seek to Vertices Start
   			print(fBuffer[vOffset][0])
   			VertBuff = bs.readBytes(fBuffer[vOffset][0])
   			rapi.rpgSetName("mesh_" + str(i))
   			rapi.rpgSetOption(noesis.RPGOPT_BIGENDIAN, 1)
   			
   			if VertType == 1:
   				rapi.rpgBindPositionBufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, 0)
   			
   			if UVtype == 1:
   				rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, UVpos)	
   			elif UVtype == 2:
   				rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_USHORT, VBsize, UVpos)	
   			elif UVtype == 3:
   				rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, UVpos)	
   			elif UVtype == 4:
   				rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_SHORT, VBsize, UVpos)	

   			if UV2type == 1:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, UV2pos)
   			elif UV2type == 2:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, UV2pos)   					
   			
   			if UV3type == 1:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, UV3pos)
   			elif UV3type == 2:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, UV3pos)
   				
   			if UV4type == 1:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, UV4pos)
   			elif UV4type == 2:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, UV4pos)      				      			
   			
   			if UV5type == 1:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, UV5pos)
   			elif UV5type == 2:
   				rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, UV5pos)      	   			

   			if COLtype == 1:
   				rapi.rpgBindColorBufferOfs(VertBuff, noesis.RPGEODATA_UBYTE, VBsize, COLpos, 4)
   			   			  				
   		
   		bs.seek(fOffset[iOffset][0], NOESEEK_ABS)
   		FaceBuff = bs.readBytes(fBuffer[iOffset][0])
   		rapi.rpgCommitTriangles(FaceBuff, noesis.RPGEODATA_USHORT, triangleCount, noesis.RPGEO_TRIANGLE, 1)
   	
   	  
   mdl = rapi.rpgConstructModel()
   mdlList.append(mdl)         #important, don't forget to put your loaded model in the mdlList
   rapi.rpgClearBufferBinds()
   rapi.rpgReset() 
   return 1